Index: /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/IRRestarterView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/IRRestarterView.cs	(revision 12804)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/IRRestarterView.cs	(revision 12804)
@@ -0,0 +1,298 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.ComponentModel;
+using System.Globalization;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Optimization.Views {
+  [View("Independent Random Restarter View")]
+  [Content(typeof(IndepdentRandomRestarter), IsDefaultView = true)]
+  public partial class IndependentRandomRestarterView : IOptimizerView {
+    protected TypeSelectorDialog algorithmTypeSelectorDialog;
+    protected virtual bool SuppressEvents { get; set; }
+
+    public new IndepdentRandomRestarter Content {
+      get { return (IndepdentRandomRestarter)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public IndependentRandomRestarterView() {
+      InitializeComponent();
+      terminationComboBox.Items.AddRange(Enum.GetValues(typeof(TerminationCriterium)).Cast<object>().ToArray());
+    }
+
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (algorithmTypeSelectorDialog != null) algorithmTypeSelectorDialog.Dispose();
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.PropertyChanged -= Content_PropertyChanged;
+      base.DeregisterContentEvents();
+    }
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.PropertyChanged += Content_PropertyChanged;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      SuppressEvents = true;
+      try {
+        if (Content == null) {
+          maxExecutionTimeTextBox.Text = String.Empty;
+          maxEvaluationsTextBox.Text = String.Empty;
+          moveCostPerSolutionTextBox.Text = String.Empty;
+          targetValueTextBox.Text = String.Empty;
+          maximizationCheckBox.CheckState = CheckState.Indeterminate;
+          terminationComboBox.SelectedIndex = -1;
+
+          algorithmViewHost.Content = null;
+          currentRunView.Content = null;
+          runsView.Content = null;
+        } else {
+          maxExecutionTimeTextBox.Text = TimeSpanHelper.FormatNatural(Content.MaximumExecutionTime);
+          maxEvaluationsTextBox.Text = Content.MaximumEvaluations.ToString();
+          moveCostPerSolutionTextBox.Text = Content.MoveCostPerSolution.ToString(CultureInfo.CurrentCulture.NumberFormat);
+          targetValueTextBox.Text = Content.TargetValue.ToString(CultureInfo.CurrentCulture.NumberFormat);
+          maximizationCheckBox.Checked = Content.Maximization;
+          terminationComboBox.SelectedItem = Content.TerminationCriterium;
+
+          algorithmViewHost.Content = Content.Algorithm;
+          currentRunView.Content = Content.CurrentRun;
+          runsView.Content = Content.Runs;
+        }
+      } finally { SuppressEvents = false; }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      maxExecutionTimeTextBox.Enabled = Content != null && !ReadOnly && !Locked;
+      maxEvaluationsTextBox.Enabled = Content != null && !ReadOnly && !Locked;
+      moveCostPerSolutionTextBox.Enabled = Content != null && !ReadOnly && !Locked;
+      targetValueTextBox.Enabled = Content != null && !ReadOnly && !Locked;
+      maximizationCheckBox.Enabled = Content != null && !ReadOnly && !Locked;
+      terminationComboBox.Enabled = Content != null && !ReadOnly && !Locked;
+      newAlgorithmButton.Enabled = Content != null && !ReadOnly;
+      openAlgorithmButton.Enabled = Content != null && !ReadOnly;
+      algorithmViewHost.Enabled = Content != null;
+      currentRunView.Enabled = Content != null;
+      runsView.Enabled = Content != null;
+    }
+
+    protected override void OnClosed(FormClosedEventArgs e) {
+      if ((Content != null) && (Content.ExecutionState == ExecutionState.Started)) {
+        //The content must be stopped if no other view showing the content is available
+        var optimizers = MainFormManager.MainForm.Views.OfType<IContentView>().Where(v => v != this).Select(v => v.Content).OfType<IAlgorithm>();
+        if (!optimizers.Contains(Content.Algorithm)) {
+          var nestedOptimizers = optimizers.SelectMany(opt => opt.NestedOptimizers);
+          if (!nestedOptimizers.Contains(Content)) Content.Stop();
+        }
+      }
+      base.OnClosed(e);
+    }
+
+    #region Event Handlers
+    #region Content events
+    private void Content_PropertyChanged(object sender, PropertyChangedEventArgs e) {
+      SuppressEvents = true;
+      try {
+        switch (e.PropertyName) {
+          case "TerminationCriterium": terminationComboBox.SelectedItem = Content.TerminationCriterium; break;
+          case "MaximumExecutionTime": maxExecutionTimeTextBox.Text = TimeSpanHelper.FormatNatural(Content.MaximumExecutionTime); break;
+          case "MaximumEvaluations": maxEvaluationsTextBox.Text = Content.MaximumEvaluations.ToString(); break;
+          case "TargetValue": targetValueTextBox.Text = Content.TargetValue.ToString(CultureInfo.CurrentCulture.NumberFormat); break;
+          case "Maximization": maximizationCheckBox.Checked = Content.Maximization; break;
+          case "MoveCostPerSolution": moveCostPerSolutionTextBox.Text = Content.MoveCostPerSolution.ToString(CultureInfo.CurrentCulture.NumberFormat); break;
+          case "Algorithm": algorithmViewHost.Content = Content.Algorithm; break;
+          case "CurrentRun": currentRunView.Content = Content.CurrentRun; break;
+          case "Runs": runsView.Content = Content.Runs; break;
+        }
+      } finally { SuppressEvents = false; }
+    }
+    #endregion
+
+    #region Control events
+    private void maxExecutionTimeTextBox_Validating(object sender, CancelEventArgs e) {
+      if (SuppressEvents) return;
+      if (InvokeRequired) {
+        Invoke((Action<object, CancelEventArgs>)maxExecutionTimeTextBox_Validating, sender, e);
+        return;
+      }
+      TimeSpan ts;
+      if (!TimeSpanHelper.TryGetFromNaturalFormat(maxExecutionTimeTextBox.Text, out ts)) {
+        e.Cancel = !maxExecutionTimeTextBox.ReadOnly && maxExecutionTimeTextBox.Enabled;
+        errorProvider.SetError(maxExecutionTimeTextBox, "Please enter a valid time span, e.g. 20 seconds ; 45s ; 4min ; 1h ; 3 hours ; 2 days ; 4d");
+      } else {
+        Content.MaximumExecutionTime = ts;
+        e.Cancel = false;
+        errorProvider.SetError(maxExecutionTimeTextBox, null);
+      }
+    }
+
+    private void maxEvaluationsTextBox_Validating(object sender, CancelEventArgs e) {
+      if (SuppressEvents) return;
+      if (InvokeRequired) {
+        Invoke((Action<object, CancelEventArgs>)maxEvaluationsTextBox_Validating, sender, e);
+        return;
+      }
+      int value;
+      if (!int.TryParse(maxEvaluationsTextBox.Text, out value)) {
+        e.Cancel = !maxEvaluationsTextBox.ReadOnly && maxEvaluationsTextBox.Enabled;
+        errorProvider.SetError(maxEvaluationsTextBox, "Please enter a valid integer number.");
+      } else {
+        Content.MaximumEvaluations = value;
+        e.Cancel = false;
+        errorProvider.SetError(maxEvaluationsTextBox, null);
+      }
+    }
+
+    private void moveCostPerSolutionTextBox_Validating(object sender, CancelEventArgs e) {
+      if (SuppressEvents) return;
+      if (InvokeRequired) {
+        Invoke((Action<object, CancelEventArgs>)moveCostPerSolutionTextBox_Validating, sender, e);
+        return;
+      }
+      double value;
+      if (!double.TryParse(moveCostPerSolutionTextBox.Text, out value)) {
+        e.Cancel = !moveCostPerSolutionTextBox.ReadOnly && moveCostPerSolutionTextBox.Enabled;
+        errorProvider.SetError(moveCostPerSolutionTextBox, "Please enter a valid integer number.");
+      } else {
+        Content.MoveCostPerSolution = value;
+        e.Cancel = false;
+        errorProvider.SetError(moveCostPerSolutionTextBox, null);
+      }
+    }
+
+    private void targetValueTextBox_Validating(object sender, CancelEventArgs e) {
+      if (SuppressEvents) return;
+      if (InvokeRequired) {
+        Invoke((Action<object, CancelEventArgs>)targetValueTextBox_Validating, sender, e);
+        return;
+      }
+      double value;
+      if (!double.TryParse(targetValueTextBox.Text, out value)) {
+        e.Cancel = !targetValueTextBox.ReadOnly && targetValueTextBox.Enabled;
+        errorProvider.SetError(targetValueTextBox, "Please enter a valid integer number.");
+      } else {
+        Content.TargetValue = value;
+        e.Cancel = false;
+        errorProvider.SetError(targetValueTextBox, null);
+      }
+    }
+
+    private void maximizationCheckBox_CheckedChanged(object sender, EventArgs e) {
+      if (SuppressEvents) return;
+      if (InvokeRequired) {
+        Invoke((Action<object, EventArgs>)maximizationCheckBox_CheckedChanged, sender, e);
+        return;
+      }
+      Content.Maximization = maximizationCheckBox.Checked;
+    }
+
+    private void terminationComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      if (SuppressEvents) return;
+      if (InvokeRequired) {
+        Invoke((Action<object, EventArgs>)terminationComboBox_SelectedIndexChanged, sender, e);
+        return;
+      }
+      Content.TerminationCriterium = (TerminationCriterium)terminationComboBox.SelectedItem;
+    }
+
+    private void newAlgorithmButton_Click(object sender, EventArgs e) {
+      if (algorithmTypeSelectorDialog == null) {
+        algorithmTypeSelectorDialog = new TypeSelectorDialog { Caption = "Select Algorithm" };
+        algorithmTypeSelectorDialog.TypeSelector.Caption = "Available Algorithms";
+        algorithmTypeSelectorDialog.TypeSelector.Configure(typeof(IAlgorithm)
+          , showNotInstantiableTypes: false, showGenericTypes: false);
+      }
+      if (algorithmTypeSelectorDialog.ShowDialog(this) == DialogResult.OK) {
+        try {
+          Content.Algorithm = (IAlgorithm)algorithmTypeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType();
+        } catch (Exception ex) {
+          ErrorHandling.ShowErrorDialog(this, ex);
+        }
+      }
+    }
+
+    private void openAlgorithmButton_Click(object sender, EventArgs e) {
+      openFileDialog.Title = "Open Algorithm";
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        newAlgorithmButton.Enabled = openAlgorithmButton.Enabled = false;
+        algorithmViewHost.Enabled = false;
+
+        ContentManager.LoadAsync(openFileDialog.FileName, delegate(IStorableContent content, Exception error) {
+          try {
+            if (error != null) throw error;
+            var algorithm = content as IAlgorithm;
+            if (algorithm == null)
+              MessageBox.Show(this, "The selected file does not contain an algorithm.", "Invalid File", MessageBoxButtons.OK, MessageBoxIcon.Error);
+            else
+              Content.Algorithm = algorithm;
+          } catch (Exception ex) {
+            ErrorHandling.ShowErrorDialog(this, ex);
+          } finally {
+            Invoke(new Action(delegate() {
+              algorithmViewHost.Enabled = true;
+              newAlgorithmButton.Enabled = openAlgorithmButton.Enabled = true;
+            }));
+          }
+        });
+      }
+    }
+
+    private void algorithmTabPage_DragEnterOver(object sender, DragEventArgs e) {
+      e.Effect = DragDropEffects.None;
+      var alg = e.Data.GetData(Constants.DragDropDataFormat) as IAlgorithm;
+      if (!ReadOnly && alg != null) {
+        if (!typeof(ISingleObjectiveHeuristicOptimizationProblem).IsAssignableFrom(alg.ProblemType))
+          return;
+        if ((e.KeyState & 32) == 32) e.Effect = DragDropEffects.Link;  // ALT key
+        else if ((e.KeyState & 4) == 4) e.Effect = DragDropEffects.Move;  // SHIFT key
+        else if (e.AllowedEffect.HasFlag(DragDropEffects.Copy)) e.Effect = DragDropEffects.Copy;
+        else if (e.AllowedEffect.HasFlag(DragDropEffects.Move)) e.Effect = DragDropEffects.Move;
+        else if (e.AllowedEffect.HasFlag(DragDropEffects.Link)) e.Effect = DragDropEffects.Link;
+      }
+    }
+
+    private void algorithmTabPage_DragDrop(object sender, DragEventArgs e) {
+      if (e.Effect != DragDropEffects.None) {
+        var algorithm = e.Data.GetData(Constants.DragDropDataFormat) as IAlgorithm;
+        if (e.Effect.HasFlag(DragDropEffects.Copy)) algorithm = (IAlgorithm)algorithm.Clone();
+        Content.Algorithm = algorithm;
+      }
+    }
+    #endregion
+    #endregion
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs	(revision 12803)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs	(revision 12804)
@@ -44,4 +44,5 @@
     /// </summary>
     private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
       this.dataTableComboBox = new System.Windows.Forms.ComboBox();
       this.label1 = new System.Windows.Forms.Label();
@@ -50,4 +51,8 @@
       this.groupComboBox = new System.Windows.Forms.ComboBox();
       this.logScalingCheckBox = new System.Windows.Forms.CheckBox();
+      this.targetsTextBox = new System.Windows.Forms.TextBox();
+      this.label3 = new System.Windows.Forms.Label();
+      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
       // 
@@ -81,8 +86,8 @@
       this.viewHost.Content = null;
       this.viewHost.Enabled = false;
-      this.viewHost.Location = new System.Drawing.Point(4, 57);
+      this.viewHost.Location = new System.Drawing.Point(4, 90);
       this.viewHost.Name = "viewHost";
       this.viewHost.ReadOnly = false;
-      this.viewHost.Size = new System.Drawing.Size(520, 291);
+      this.viewHost.Size = new System.Drawing.Size(520, 258);
       this.viewHost.TabIndex = 2;
       this.viewHost.ViewsLabelVisible = true;
@@ -122,15 +127,41 @@
       this.logScalingCheckBox.CheckedChanged += new System.EventHandler(this.logScalingCheckBox_CheckedChanged);
       // 
-      // RunCollectionECDFView
+      // targetsTextBox
+      // 
+      this.targetsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.targetsTextBox.Location = new System.Drawing.Point(69, 57);
+      this.targetsTextBox.Name = "targetsTextBox";
+      this.targetsTextBox.Size = new System.Drawing.Size(455, 20);
+      this.targetsTextBox.TabIndex = 6;
+      this.targetsTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.targetsTextBox_Validating);
+      // 
+      // label3
+      // 
+      this.label3.AutoSize = true;
+      this.label3.Location = new System.Drawing.Point(3, 60);
+      this.label3.Name = "label3";
+      this.label3.Size = new System.Drawing.Size(46, 13);
+      this.label3.TabIndex = 1;
+      this.label3.Text = "Targets:";
+      // 
+      // errorProvider
+      // 
+      this.errorProvider.ContainerControl = this;
+      // 
+      // RunCollectionRLDView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.targetsTextBox);
       this.Controls.Add(this.logScalingCheckBox);
       this.Controls.Add(this.groupComboBox);
       this.Controls.Add(this.label2);
       this.Controls.Add(this.viewHost);
+      this.Controls.Add(this.label3);
       this.Controls.Add(this.label1);
       this.Controls.Add(this.dataTableComboBox);
-      this.Name = "RunCollectionECDFView";
+      this.Name = "RunCollectionRLDView";
       this.Size = new System.Drawing.Size(527, 374);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -146,4 +177,7 @@
     private System.Windows.Forms.ComboBox groupComboBox;
     private System.Windows.Forms.CheckBox logScalingCheckBox;
+    private System.Windows.Forms.TextBox targetsTextBox;
+    private System.Windows.Forms.Label label3;
+    protected System.Windows.Forms.ErrorProvider errorProvider;
   }
 }
Index: /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs	(revision 12803)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs	(revision 12804)
@@ -42,4 +42,6 @@
     }
 
+    private double[] levels;
+
     private bool suppressUpdates;
     private readonly IndexedDataTable<double> combinedDataTable;
@@ -167,7 +169,12 @@
         var table = (string)dataTableComboBox.SelectedItem;
         if (string.IsNullOrEmpty(table)) return;
-        var maximum = Content.Select(x => ((IndexedDataTable<double>)x.Results[table]).Rows.First().Values.Max(y => y.Item2)).Max();
-        var minimum = Content.Select(x => ((IndexedDataTable<double>)x.Results[table]).Rows.First().Values.Min(y => y.Item2)).Min();
-        var levels = Enumerable.Range(0, 51).Select(x => maximum - (x / 50.0) * (maximum - minimum)).ToArray();
+        if (levels == null) {
+          var worst = Content.Select(x => ((IndexedDataTable<double>)x.Results[table]).Rows.First().Values.Max(y => y.Item2)).First();
+          var best = Content.Select(x => ((IndexedDataTable<double>)x.Results[table]).Rows.First().Values.Min(y => y.Item2)).Last();
+          levels = Enumerable.Range(0, 51).Select(x => worst + (x / 50.0) * (best - worst)).ToArray();
+          suppressTargetsEvents = true;
+          targetsTextBox.Text = string.Join(" ; ", levels);
+          suppressTargetsEvents = false;
+        }
         var selectedGroup = (string)groupComboBox.SelectedItem;
         if (string.IsNullOrEmpty(selectedGroup)) return;
@@ -184,25 +191,23 @@
             var resultsTable = (IndexedDataTable<double>)run.Results[table];
             xAxisTitles.Add(resultsTable.VisualProperties.XAxisTitle);
-            var graph = new LinkedList<Tuple<double, double>>(resultsTable.Rows.First().Values);
-            var current = graph.First.Next;
-            // prune convergence graph to obtain first hit times only
-            while (current != null) {
-              if (current.Value.Item2.IsAlmost(current.Previous.Value.Item2)) {
-                var h = current;
-                current = current.Previous;
-                graph.Remove(h);
-              }
-              current = current.Next;
-            }
+            var values = resultsTable.Rows.First().Values;
+            var maximization = values.First().Item2 < values.Last().Item2;
             var i = 0;
-            current = graph.First;
-            while (i < levels.Length && current != null) {
-              if (current.Value.Item2 < levels[i]) {
-                if (hits.ContainsKey(current.Value.Item1))
-                  hits[current.Value.Item1]++;
-                else hits[current.Value.Item1] = 1;
+            var j = 0;
+            var current = values[j];
+            var prev = Tuple.Create(-1.0, double.NaN);
+            while (i < levels.Length) {
+              if ((double.IsNaN(prev.Item2) || prev.Item2 != current.Item2)
+                  && (maximization && current.Item2 >= levels[i]
+                  || !maximization && current.Item2 <= levels[i])) {
+                if (hits.ContainsKey(current.Item1))
+                  hits[current.Item1]++;
+                else hits[current.Item1] = 1;
                 i++;
               } else {
-                current = current.Next;
+                j++;
+                if (j >= values.Count) break;
+                prev = current;
+                current = values[j];
               }
             }
@@ -266,4 +271,28 @@
       combinedDataTable.VisualProperties.XAxisLogScale = logScalingCheckBox.Checked;
     }
+
+    private bool suppressTargetsEvents;
+    private void targetsTextBox_Validating(object sender, CancelEventArgs e) {
+      if (suppressTargetsEvents) return;
+      var targetStrings = targetsTextBox.Text.Split(new[] { ';', '\t', ' ' }, StringSplitOptions.RemoveEmptyEntries);
+      var targetList = new List<double>();
+      foreach (var ts in targetStrings) {
+        double t;
+        if (!double.TryParse(ts, out t)) {
+          errorProvider.SetError(targetsTextBox, "Not all targets can be parsed: " + ts);
+          e.Cancel = true;
+          return;
+        }
+        targetList.Add(t);
+      }
+      if (targetList.Count == 0) {
+        errorProvider.SetError(targetsTextBox, "Give at least one target value!");
+        e.Cancel = true;
+        return;
+      }
+      e.Cancel = false;
+      errorProvider.SetError(targetsTextBox, null);
+      levels = targetList.ToArray();
+    }
   }
 }
Index: /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 12803)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 12804)
@@ -97,4 +97,8 @@
 
     private void Content_PropertyChanged(object sender, PropertyChangedEventArgs e) {
+      if (InvokeRequired) {
+        Invoke((Action<object, PropertyChangedEventArgs>)Content_PropertyChanged, sender, e);
+        return;
+      }
       if (e.PropertyName == "Color") {
         if (InvokeRequired) this.Invoke((Action)UpdateColor, null);
@@ -112,4 +116,8 @@
 
     private void ParametersOnItemsChanged(object sender, CollectionItemsChangedEventArgs<KeyValuePair<string, IItem>> e) {
+      if (InvokeRequired) {
+        Invoke((Action<object, CollectionItemsChangedEventArgs<KeyValuePair<string, IItem>>>)ParametersOnItemsChanged, sender, e);
+        return;
+      }
       foreach (var item in e.OldItems) {
         listView.Items.Remove(parametersItemToListViewItem[item.Key]);
@@ -124,4 +132,8 @@
 
     private void ParametersOnItemsRemoved(object sender, CollectionItemsChangedEventArgs<KeyValuePair<string, IItem>> e) {
+      if (InvokeRequired) {
+        Invoke((Action<object, CollectionItemsChangedEventArgs<KeyValuePair<string, IItem>>>)ParametersOnItemsRemoved, sender, e);
+        return;
+      }
       foreach (var item in e.Items) {
         listView.Items.Remove(parametersItemToListViewItem[item.Key]);
@@ -131,4 +143,8 @@
 
     private void ResultsOnItemsChanged(object sender, CollectionItemsChangedEventArgs<KeyValuePair<string, IItem>> e) {
+      if (InvokeRequired) {
+        Invoke((Action<object, CollectionItemsChangedEventArgs<KeyValuePair<string, IItem>>>)ResultsOnItemsChanged, sender, e);
+        return;
+      }
       foreach (var item in e.OldItems) {
         listView.Items.Remove(resultsItemToListViewItem[item.Key]);
@@ -143,4 +159,8 @@
 
     private void ResultsOnItemsRemoved(object sender, CollectionItemsChangedEventArgs<KeyValuePair<string, IItem>> e) {
+      if (InvokeRequired) {
+        Invoke((Action<object, CollectionItemsChangedEventArgs<KeyValuePair<string, IItem>>>)ResultsOnItemsRemoved, sender, e);
+        return;
+      }
       foreach (var item in e.Items) {
         listView.Items.Remove(resultsItemToListViewItem[item.Key]);
